<?php
// $id$
/**
 * @file
 * Provide checkout implementation for receipting
 */

/**
 * Implementation of hook_checkout_init().
 */
function ec_receipt_checkout_init(&$form_state, &$form) {
  $txn =& $form_state['storage']['txn'];

  $txn->currency = variable_get('ec_default_currency', NULL);

  if (empty($form_state['storage']['rtypes'])) {
    $form_state['storage']['rtypes'] = ec_receipt_type_filter(array(
      'currencies_supported' => $txn->currency,
      'allow_payments' => TRUE,
    ));
  }

  if (isset($_REQUEST['payment_method']) && isset($form_state['storage']['rtypes'][$_REQUEST['payment_method']])) {
    $txn->payment_method = $_REQUEST['payment_method'];
  }
  else {
    $types = array_keys($form_state['storage']['rtypes']);
    $txn->payment_method = $types[0];
  }
}

/**
 * Implementation of hook_checkout_form().
 */
function ec_receipt_checkout_form(&$form_state, &$form) {
  $txn =& $form_state['storage']['txn'];

  $form['receipt_no'] = array(
    '#type' => 'value',
    '#value' => '',
  );
  $form['ec_receipt']['ec_receipt_name'] = array(
    '#value' => ec_receipt_checkout_types(ec_receipt_get_types('type', $txn->payment_method)),
    '#weight' => -9,
  );
  if ($pform = ec_receipt_invoke($txn->payment_method, 'payment_form', 'transaction', $txn)) {
    $form['ec_receipt']['payment_form'] = array(
      '#tree' => TRUE,
    );
    $form['ec_receipt']['payment_form']+= $pform;
  }
  $form['ec_receipt']['#theme'] = 'ec_receipt_review_form';
}

/**
 * Implementation of hook_checkout_validate().
 */
function ec_receipt_checkout_validate(&$form_state, &$form) {
  if ($form_state['clicked_button']['#value'] == t('Place your order') && !form_get_errors()) {
    $txn =& $form_state['storage']['txn'];

    $txn->receipt_no = ec_receipt_payment_process('transaction', $txn);
  }
}

/**
 * Implementation of hook_checkout_submit().
 */
function ec_receipt_checkout_post_submit(&$txn) {
  $alloc[] = array(
    'type' => 'transaction',
    'id' => $txn->txnid,
  );
  if (empty($txn->receipt_no)) {
    return ec_receipt_payment_goto('transaction', $txn, $alloc);
  }
  else {
    if ($receipt = ec_receipt_load($txn->receipt_no)) {
      ec_receipt_allocate($receipt, $alloc);
    }
  }
  return variable_get('ec_receipt_return_url', 'node');
}

